#include <CapacitiveSensor.h>
//#include <Servo.h> 


#include <SPI.h>

//Add the SdFat Libraries
#include <SdFat.h>
#include <SdFatUtil.h>

//and the MP3 Shield Library
#include <SFEMP3Shield.h>

// Below is not needed if interrupt driven. Safe to remove if not using.

//#if defined(USE_MP3_REFILL_MEANS) && USE_MP3_REFILL_MEANS == USE_MP3_Timer1
//  #include <TimerOne.h>
//#elif defined(USE_MP3_REFILL_MEANS) && USE_MP3_REFILL_MEANS == USE_MP3_SimpleTimer
//  #include <SimpleTimer.h>
//#endif

/**
 * \brief Object instancing the SdFat library.
 *
 * principal object for handling all SdCard functions.
 */
SdFat sd;

/**
 * \brief Object instancing the SFEMP3Shield library.
 *
 * principal object for handling all the attributes, members and functions for the library.
 */
SFEMP3Shield MP3player;

int touchedCutoff = 900;
int ledPin = 13;

int total1 = 300;

//Servo myservo;  // create servo object to control a servo 
                // a maximum of eight servo objects can be created 
                
//int pos = 0;    // variable to store the servo position 

/* 
* CapitiveSense Library Demo Sketch
* Paul Badger 2008
* Slightly adapted by Bare Conductive 2011 
* Uses a high value resistor e.g. 10 megohm between send pin and receive pin
* Resistor effects sensitivity, experiment with values, 50 kilohm - 50 megohm. Larger resistor values yield larger sensor values.
* Receive pin is the sensor pin - try different amounts of Bare Paint
* Best results are obtained if sensor foil and wire is covered with an insulator such as paper or plastic sheet
*/


CapacitiveSensor   cs_4_2 = CapacitiveSensor(10,5);         // 10 megohm resistor between pins 4 & 2, pin 2 is sensor pin, add Bare Paint
// CapSense   cs_4_5 = CapSense(4,5);          // OPTIONAL: for sensor 2, 10 megohm resistor between pins 4 & 6, pin 6 is sensor pin, add Bare Paint
// CapSense   cs_4_8 = CapSense(4,8);          // OPTIONAL: for sensor 3, 10 megohm resistor between pins 4 & 8, pin 8 is sensor pin, add Bare Paint

void setup()                 
{
  
//  digitalWrite(ledPin, LOW);
  
  uint8_t result; //result code from some function as to be tested at later time.
  
//   myservo.attach(11);  // attaches the servo on pin 9 to the servo object 
//  pinMode(ledPin, OUTPUT);
   cs_4_2.set_CS_AutocaL_Millis(0xFFFFFFFF);     // turn off autocalibrate on channel 1 - just as an example   
   Serial.begin(115200);
   
   //Initialize the SdCard.
  if(!sd.begin(SD_SEL, SPI_HALF_SPEED)) sd.initErrorHalt();
  if(!sd.chdir("/")) sd.errorHalt("sd.chdir");
//delay(3000);
//sd.begin();

  //Initialize the MP3 Player Shield
  result = MP3player.begin();
  //check result, see readme for error codes.
//  if(result != 0) {
//    Serial.print(F("Error code: "));
//    Serial.print(result);
//    Serial.println(F(" when trying to start MP3 player"));
//    if( result == 6 ) {
//      Serial.println(F("Warning: patch file not found, skipping.")); // can be removed for space, if needed.
//      Serial.println(F("Use the \"d\" command to verify SdCard can be read")); // can be removed for space, if needed.
//    }
  }

//#if (0)
//  // Typically not used by most shields, hence commented out.
////  Serial.println(F("Applying ADMixer patch."));
//  if(MP3player.ADMixerLoad("admxster.053") == 0) {
////    Serial.println(F("Setting ADMixer Volume."));
//    MP3player.ADMixerVol(-3);
//  }
//#endif
   
  


void loop()                    

{   
 
 #if defined(USE_MP3_REFILL_MEANS) \
    && ( (USE_MP3_REFILL_MEANS == USE_MP3_SimpleTimer) \
    ||   (USE_MP3_REFILL_MEANS == USE_MP3_Polled)      )

  MP3player.available();
#endif

 

//  delay(100);
  
  uint8_t result; // result code from some function as to be tested at later time.

  // Note these buffer may be desired to exist globably.
  // but do take much space if only needed temporarily, hence they are here.
  

//  Serial.print(F("Received command: "));
//  Serial.write(key_command);
//  Serial.println(F(" "));

  //if s, stop the current track
//  #if USE_MULTIPLE_CARDS
//    sd.chvol(); // assign desired sdcard's volume.
//#endif
//
//

//MP3player.setVolume(100);

//uint16_t playspeed = MP3player.getPlaySpeed();
//  
//  playspeed = 1;
//  
//  MP3player.setPlaySpeed(playspeed);
result = MP3player.playTrack(1);


long start = millis();    
long total1 =  cs_4_2.capacitiveSensor(30);   
// long total2 =  cs_4_5.capSense(30);     // OPTIONAL for sensor 2   
// long total3 =  cs_4_8.capSense(30);    // OPTIONAL for sensor 3      

// Serial.print(millis() - start);                      // OPTIONAL: check on performance in milliseconds   
// Serial.print(" ");                                     // OPTIONAL: tab character for debug windown spacing

Serial.println(total1);                                // OPTIONAL: To use additional sensors,change Serial.println to Serial.print for proper window spacing    
//Serial.print(" ");                               // OPTIONAL: tab character for window spacing for sensor output 2    
//Serial.print(total2);                           // OPTIONAL: print sensor output 2    
//Serial.print(" ");                               // OPTIONAL: tab character character for sensor output 3    
//Serial.println(total3);                       // print sensor output 3

//delay(20);  
 

 // arbitrary delay to limit data to serial port 
// Serial.println(pos);

//digitalWrite(ledPin, LOW);





//if (total1 > 500 && total1 < 800) {
  
  
  
//   if (total1 >= 500 && total1 < 800) {
//  
////  uint16_t playspeed = MP3player.getPlaySpeed();
////  
////  playspeed = 3;
//  
//  MP3player.setPlaySpeed(playspeed);
//  
//  }
  
  
//}



if (total1 > touchedCutoff) {
  
  
  
   MP3player.stopTrack();
   
  
   
   result = MP3player.playTrack(2);
   
    
  
   
   delay(3000);
  
//   for(pos = 50; pos > 10; pos -= 1)  // goes from 0 degrees to 180 degrees 
//  {                                  // in steps of 1 degree 
//    myservo.write(pos);              // tell servo to go to position in variable 'pos'
//  } 
//    delay(15);   
//     digitalWrite(ledPin, LOW);
//  digitalWrite(ledPin, LOW);
//delay(150);   
//digitalWrite(ledPin, HIGH);
//delay(1000);   
//digitalWrite(ledPin, LOW);
//delay(150);   
//digitalWrite(ledPin, HIGH);
//delay(1000);
//digitalWrite(ledPin, LOW);
//delay(150);   
////digitalWrite(ledPin, HIGH);
////delay(1000);
////digitalWrite(ledPin, LOW);
////delay(150);   
////digitalWrite(ledPin, HIGH);
////delay(1000);
////digitalWrite(ledPin, LOW);
////delay(150);   
////digitalWrite(ledPin, HIGH);
////delay(1000);
////digitalWrite(ledPin, LOW);
//// waits 15ms for the servo to reach the position 
//  
//  for(pos = 10; pos<=50; pos+=1)     // goes from 180 degrees to 0 degrees 
//  {                                
//    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
//    delay(15);                       // waits 15ms for the servo to reach the position 
//  } 
//    delay(1000); 
//    digitalWrite(ledPin, LOW);

} 

else

{
  
  
}
  
  

}

 

